#include <qurloperator.h>
#include <unistd.h>
#include <qqueue.h>
#include <iostream>
#include <qtimer.h>
#include <qapplication.h>

using namespace std;

class URLList : public QObject {
Q_OBJECT
private:
	bool connected;
	int maxtime;
	QString current;
	QUrlOperator op;
	QQueue<QString> queue;
	QTimer *timer;
public:
	URLList(int);
	~URLList();
	void writeList(const QString &);
public slots:
	void slotInsertEntries(const QValueList<QUrlInfo>&,QNetworkOperation*);
	void slotStart(QNetworkOperation *);
	void slotFinished(QNetworkOperation *);
	void timeout();
};
