#! /usr/bin/perl
# Copyright (C) 2001  Jos van den Oever <Jos.vandenOever@FenK.wau.nl> , Jan van Haarst <jan@vanhaarst.net>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

# doall.pl
# 	zet deze in je crontab om ieder uur op iedere host hostlisting te draaien
# hostlisting.pl
# 	kijkt of de file die overeenkomt met de ip geupdate moet worden en doet dit zonodig
# isup
# 	cgi-bin die icoontje up of down stuurt afhankelijk van of de host up of down is
# findsmb
# 	simpel gezegd: de databasetextfiles greppen en formatteren (cgi-bin)

#! /usr/bin/perl -W
use lib "/usr/lib/perl5/5.005/i386-linux/";
use lib "/usr/local/lib/perl5/site_perl/5.6.1/";
use lib "/usr/local/lib/perl5/site_perl/5.6.1/i686-linux";
use strict;
#use DBIx::Profile; # show debug data on timing of database actions
use DBI;

# remove records older than two days

# connect to database
my $dsn                 =       'DBI:mysql:filefinder:localhost';
my $db_user_name        =       'filefind';
my $db_password         =       'crawler=kewl';
my ($id, $password);
my $dbh = DBI->connect( $dsn, $db_user_name,$db_password)|| die "Database connection not made: $DBI::errstr";

# delete stale hosts
my $sth = $dbh->prepare(qq{
DELETE FROM host 
	WHERE 
		UNIX_TIMESTAMP(now())-UNIX_TIMESTAMP(last_crawled) > (2*24*60*60)
});
$sth->execute();

# delete stale files
my $sth = $dbh->prepare(qq{
    DELETE FROM files
	WHERE 
		UNIX_TIMESTAMP(now())-UNIX_TIMESTAMP(added) > (2*24*60*60)
});
$sth->execute();
$sth->finish(); # we're done with this query

$dbh ->disconnect()|| die "Database disconnection not made: $DBI::errstr";
#$dbh->printProfile();

