#
# ALLE DATABASE executes ZIJN UITGECOMMEND
# DIT VANWEGE OVERTOLLIGE ONNODIGE LOAD DIE HET VEROORZAAKT
#




#! /usr/bin/perl
use strict;
use DBI;
use Date::Parse;
# Copyright (C) 2001  Jos van den Oever <Jos.vandenOever@FenK.wau.nl> , Jan van Haarst <jan@vanhaarst.net>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

# doall.pl
# 	zet deze in je crontab om ieder uur op iedere host hostlisting te draaien
# hostlisting.pl
# 	kijkt of de file die overeenkomt met de ip geupdate moet worden en doet dit zonodig
# isup
# 	cgi-bin die icoontje up of down stuurt afhankelijk van of de host up of down is
# findsmb
# 	simpel gezegd: de databasetextfiles greppen en formatteren (cgi-bin)

# update period
my $period = 24 * 60 * 60;

# check arguments
if (!$ARGV[0] || ($ARGV[1] && $ARGV[1] ne "now")
	|| $ARGV[0] !~ m/^\d\d?\d?\.\d\d?\d?\.\d\d?\d?\.\d\d?\d?$/) {
	die("usage: $0 ip-address\n");
}
my $ip = $ARGV[0];

# Shorten update period if now was added.
if ($ARGV[1] && $ARGV[1] eq "now"){
$period = 5 * 60;
}
else {
$period = 24 * 60 * 60;
}

# check if file needs updating 
# TODO add an database check for date of hostrecord
my $mtime = (stat $ip)[9];
my $time = time();
if ($mtime && $time - $mtime < $period) {
	exit;
}

# check if host is up and sharing

#if (`nmap -P0 -p 139 -T 5 $ip` !~ m/139\/tcp/) {
if (`nmap -P0 -p 139 -T 5 $ip` !~ m/139/) {
#	print "$ip: host not open or nmap not found\n";
	exit;
}

# get the name of the host
my @lines1 = `nmblookup -A $ip`;
my $name;
my $group;
foreach (@lines1) {
	if (m/^[\t ]+([^\t]+[^ \t])[ \t]+<00> - <GROUP>/) {
		$group = $1;
#	print	$group;
	} elsif (m/^[\t ]+([^\t]+[^ \t])[ \t]+<00> - /) {
		$name = $1;
#	print	$name;
	}
}
if (!$name) {
	exit;
}

# connect to database
my $dsn 		= 	'DBI:mysql:filefinder:localhost';
my $db_user_name 	= 	'filefind';
my $db_password 	= 	'crawler=kewl';
my ($id, $password);
my $dbh = DBI->connect(	$dsn, $db_user_name,$db_password)|| die "Database connection not made: $DBI::errstr";

# remove old records

# first, get ID from database.
my $sth = $dbh->prepare(qq{
    SELECT id FROM host
        WHERE
	ip		= "$ip"
});
#$sth->execute();

my $id;
($id) = $sth->fetchrow_array();
$sth->finish(); # we're done with this query

# TODO hier moet nog een check op lengte van de array tussen, Als 0, skip. Als 1 doe. Als >1 roep shit.

# host
my $sth = $dbh->prepare(qq{
    DELETE FROM host
	WHERE
	id		= "$id"
});
#$sth->execute();
$sth->finish(); # we're done with this query
# files
my $sth = $dbh->prepare(qq{
    DELETE FROM files
	WHERE
	hostnr		= "$id"
});
#$sth->execute();
$sth->finish(); # we're done with this query

# start new record

# insert hostrecord
my $sth = $dbh->prepare(qq{
    INSERT INTO host
	SET
	name 		= "$name",
	ip		= "$ip",
# TODO maak toevoegen van groupname afhankelijk van aanwezigheid van die naam.
	groupname 	= "$group"
});
#$sth->execute();
$sth->finish(); # we're done with this query

# new ID for the host
my $new_id;
$new_id = $sth->{mysql_insertid};

# process all shares
@lines1 =`smbclient -L\"$name\" -I$ip -N`;
open(FH, "> $ip") or die("could not write to $ip\n");
open(FH2, ">> filesnotlisted");
my $togo = 3;
if (-e "links/$ip") {
	`rm links/$ip`;
}
foreach (@lines1) {
	if (m/Sharename.*Type.*Comment/) {
		$togo = 2;
	} elsif ($togo == 2) {
		$togo--;
	} elsif ($togo == 1) {
		if (m/^ *$/) {
			$togo = 0;
		} elsif(m/^\t(.{1,13}\S)\s+Disk {6}(.*)$/) {
			my $share = $1;
			my $comment = $2;
#			writelinks($ip, $name, $share);
#			print "smb://$ip/$share\n";
			my @lines2;
			if ($group) {
				@lines2 = `smbclient \"//$name/$share\" -W\"$group\" -I$ip -N -c 'recurse on;ls' 2> /dev/null`;
			} else {
				@lines2 = `smbclient \"//$name/$share\" -I$ip -N -c 'recurse on;ls' 2> /dev/null`;
			}
			my $dir = "/";
			foreach (@lines2) {
				#match dir, redundant info: discard
				if (m/^  (.*\S)\s+DA?H?S?R? {8}0  .{24}$/) {
				#match file
# this matching is not perfect
# i don't know how to make a difference between a file that is called
# 'filename             A' and a file called 'filename' with the A bit set
# solution for now: don't match files that end on A, H, S, or R with more
# than 1 space in front of that.
				} elsif (m/^  (.*\S)\s+(\d+)  (.{24})$/) {
					my $file = $1;
					my $size = $2;
					my $date = str2time($3);
					$file =~ s/\s\s+A?H?S?R?$//;
					if ($file !~ m/wm[fa]$/i) 
					{
			print FH "//$name/$share$dir$file\n";
			
# insert filedata into database
my $sth = $dbh->prepare(qq{
    INSERT INTO files
	SET
	hostnr	 		= "$new_id",
	protocol		= "smb",
	share	 		= "$share",
	path			= "$dir",
	name	 		= "$file",
	size			= $size,
	#date			= $date,
	extension		= ""
	});
#$sth->execute();
$sth->finish(); # we're done with this query
					}
				} elsif (m/^[\/\\]/) {
					chomp;
					s/\\/\//g;
					s/([^\/])$/$1\//;
					$dir = $_;
					print FH "//$name/$share$dir\n";
				} elsif (m/^  /) {
					# debug: all non-matched lines are printed
					print FH2;
				}
			}
		}
	}
}
close(FH);
close(FH2);
$dbh ->disconnect()|| die "Database disconnection not made: $DBI::errstr";

if (-s $ip) {
#	`cat message|smbclient -M\"$name\" -I$ip -UZOEKENMAAR`;
}

sub writelinks {
	my $ip = shift;
	my $name = shift;
	my $share = shift;
	`echo ln -s \\\'/smb/$ip=$share\\\' \\\'$name=$share\\\' >> links/$ip`;
}
